# FROM php:7.4-fpm
FROM php:8.1-fpm

# make sure apt is up to date
RUN apt-get update --fix-missing
RUN apt-get install -y curl
RUN apt-get install -y build-essential libssl-dev zlib1g-dev libpng-dev libjpeg-dev libfreetype6-dev

# Install PDO for MySQL
RUN docker-php-ext-install pdo pdo_mysql mysqli

RUN docker-php-ext-configure gd  \
    && docker-php-ext-install gd

# --with-freetype-dir=/usr/include/ --with-jpeg-dir=/usr/include/

# ioncube loader
COPY config/ioncube_loader_lin_8.1.so /usr/local/lib/php/extensions/no-debug-non-zts-20210902/
# COPY config/ioncube_loader_lin_7.4.so /usr/local/lib/php/extensions/no-debug-non-zts-20210902/

# php.ini
COPY config/php.ini /usr/local/etc/php/
