<?PHP
$pgSecurityLevel = 90;
define('_RootPATH', '../');
require('../wtk/wtkLogin.php');
session_write_close();  // so rest of website still works
date_default_timezone_set('America/Los_Angeles'); // equivalent to MySQL 'US/Pacific'

$pgMarketingCampaign = 'sales5';

$pgMode = wtkGetParam('Mode');
if ($pgMode == ''):
    if ($gloRNG == 'FupSales3'):
        $pgMode = $gloRNG;
        $pgMarketingCampaign = 'sales3fup';
    endif;
    if ($gloId == $pgMarketingCampaign):
        $pgMode = $gloRNG;
    else:
        $pgMode = $gloId;
    endif;
endif;

$pgHourMin   = date('H:i');
if (($pgHourMin >= '06:00') && ($pgHourMin < '07:30')):
    $pgTimeZone = 'US/Eastern';
elseif (($pgHourMin >= '07:30') && ($pgHourMin < '08:30')):
    $pgTimeZone = 'US/Central';
elseif (($pgHourMin >= '08:30') && ($pgHourMin < '09:40')):
    $pgTimeZone = 'US/Mountain';
elseif (($pgHourMin >= '09:40') && ($pgHourMin < '11:00')):
    $pgTimeZone = 'US/Pacific';
else:
    $pgTimeZone = '';
endif;
// Good Email Template HTML at:
// https://colorlib.com/etc/email-template/2/index.html
// $gloTechSupport = 'alec.sherman@me.com'; // 2FIX testing for phone email
// $gloTechSupport = 'nice.nerd2@gmail.com'; // 2FIX gmail testing
// $gloTechSupport = 'jmorgan@rentadousa.com';

$gloEmailFromAddress = $gloEmailBulkAddress;
$gloBulkEmailing = true;
//wtkSqlExec("SET sql_mode = 'STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION'", []);

$pgSQL =<<<SQLVAR
SELECT `UID`, `Subject`, `EmailBody`
 FROM `wtkEmailTemplate`
WHERE `EmailCode` = :EmailCode
SQLVAR;
$pgSqlFilter = array (
    'EmailCode' => $pgMarketingCampaign
);
wtkSqlGetRow($pgSQL, $pgSqlFilter);

$pgEmailUID = wtkSqlValue('UID');
$pgSubject  = wtkSqlValue('Subject');
$pgEmailBody = wtkSqlValue('EmailBody');
$pgSubject  = wtkReplace($pgSubject, '@CompanyName@', $gloCoName);
$pgSaveArray = array (
    'EmailUID' => $pgEmailUID,
    'FromUID' => 0,
    'EmailType' => 'sales'
);

$pgHtm = '';
switch ($pgMode):
    case 'SendOne':
        $pgSQL =<<<SQLVAR
SELECT CRC32(s.`UID`) AS `Hash`, s.`ProspectUID`, s.`Email`, s.`FirstName`, s.`LastName`
 FROM `wtkProspectStaff` s
WHERE s.`UID` = :UID
SQLVAR;
        $pgSqlFilter = array('UID' => $gloRNG );
        wtkSqlGetRow($pgSQL, $pgSqlFilter);
        $pgToEmail = wtkSqlValue('Email');
        $pgProspectUID = wtkSqlValue('ProspectUID');
        $pgBody = wtkReplace($pgEmailBody, '@FirstName@', wtkSqlValue('FirstName'));
        $pgBody = wtkReplace($pgBody, '@LastName@', wtkSqlValue('LastName'));
        $pgBody = wtkReplace($pgBody, '@hash@', wtkSqlValue('Hash'));
        $pgSaveArray['OtherUID'] = $gloRNG;
        if ($pgMarketingCampaign == 'sales5'):
            $pgTmp = wtkNotifyViaEmail($pgSubject, $pgBody, $pgToEmail, $pgSaveArray,'','emailSales2.htm');
        else:
            $pgTmp = wtkNotifyViaEmail($pgSubject, $pgBody, $pgToEmail, $pgSaveArray,'','emailSales.htm');
        endif;
        $pgUpdSQL =<<<SQLVAR
UPDATE `wtkProspectStaff`
  SET `EmailsSent` = (`EmailsSent` + 1)
WHERE `UID` = :UID
SQLVAR;
        wtkSqlExec($pgUpdSQL, $pgSqlFilter);
        $pgSQL =<<<SQLVAR
UPDATE `wtkProspects`
  SET `ProspectStatus` = 'email'
WHERE `UID` = :UID AND `ProspectStatus` = 'new'
SQLVAR;
        $pgSqlFilter = array('UID' => $pgProspectUID);
        wtkSqlExec($pgSQL, $pgSqlFilter);
        $pgHtm .=<<<htmVAR
<div class="row">
    <div class="col s12"><br>
        <div class="card">
            <div class="card-content">
                <h2>Email Sent</h2>
                <p><strong>$pgSubject</strong> email sent email to:<br>$pgToEmail</p>
            </div>
        </div>
    </div>
</div>
htmVAR;
        break;
    case 'FupSales3':
        $pgSQL =<<<SQLVAR
SELECT s.`UID`, CRC32(s.`UID`) AS `Hash`, s.`ProspectUID`, s.`Email`,
    COALESCE(s.`FirstName`,'') AS `FirstName`,
    COALESCE(s.`LastName`,'') AS `LastName`
FROM `wtkProspectStaff` s
  INNER JOIN `wtkProspects` p ON p.`UID` = s.`ProspectUID`
WHERE s.`DoNotContact` = :DoNotContact
    AND s.`LinksClicked` > :LinksClicked
    AND p.`ProspectStatus` NOT IN ('close','sold')
GROUP BY s.`Email`
ORDER BY s.`UID` ASC LIMIT 200
SQLVAR;
        $pgSqlFilter = array (
            'DoNotContact' => 'N',
            'LinksClicked' => 0
        );
        $pgSQL = wtkSqlPrep($pgSQL);
        $pgPDO = $gloWTKobjConn->prepare($pgSQL);
        $pgPDO->execute($pgSqlFilter);
        $pgUpdSQL =<<<SQLVAR
UPDATE `wtkProspectStaff`
  SET `EmailsSent` = (`EmailsSent` + 1)
WHERE `UID` = :UID
SQLVAR;
        $pgCnt = 0;
        $pgUpdSqlFilter = array('UID' => 0);
        $pgProFilter = array('ProUID' => 0);
        $pgList = '';
        while ($pgRow = $pgPDO->fetch(PDO::FETCH_ASSOC)):
            $pgCnt ++;
            $pgToEmail = $pgRow['Email'];
            $pgUserUID = $pgRow['UID'];
            $pgUpdSqlFilter['UID'] = $pgUserUID;
            $pgSaveArray['OtherUID'] = $pgUserUID;
            $pgBody = wtkReplace($pgEmailBody, '@FirstName@', $pgRow['FirstName']);
            $pgBody = wtkReplace($pgBody, '@LastName@', $pgRow['LastName']);
            $pgBody = wtkReplace($pgBody, '@hash@', $pgRow['Hash']);
            if ($pgMarketingCampaign == 'sales5'):
                $pgTmp = wtkNotifyViaEmail($pgSubject, $pgBody, $pgToEmail, $pgSaveArray,'','emailSales2.htm');
            else:
                $pgTmp = wtkNotifyViaEmail($pgSubject, $pgBody, $pgToEmail, $pgSaveArray,'','emailSales.htm');
            endif;
            wtkSqlExec($pgUpdSQL, $pgUpdSqlFilter);
            $pgProspectUID = $pgRow['ProspectUID'];
            if ($pgCnt < 20):
                if (strlen($pgToEmail) > 18):
                    $pgList .= '<div class="col m4 s6">';
                else:
                    $pgList .= '<div class="col m3 s4">';
                endif;
                $pgList .= $pgUserUID . ': ' . $pgToEmail . '</div>' . "\n";
            endif;
        endwhile;
        $pgAddS = 's';
        if ($pgCnt > 20):
            $pgList .= '<div class="col m3 s4">and more...</div>' . "\n";
        elseif ($pgCnt == 1):
            $pgAddS = '';
        endif;
        $pgForm  = wtkFormHidden('id', $gloRNG);
        //        $pgForm .= wtkFormHidden('Mode', 'SendOne');
        $pgPageTime = round(microtime(true) - $gloPageStart,4);
        $pgHtm =<<<htmVAR
<br>
<div class="container">
<div class="card bg-second">
<div class="card-content">
  <h3>"$pgSubject" email sent to:</h3><br>
  <form id="FemailResults" name="FemailResults">
  $pgForm
  </form>
  <div class="row">
      $pgList
  </div>
</div>
<div class="card-action">Finished sending $pgCnt email$pgAddS in $pgPageTime seconds.</div>
</div>
</div>
htmVAR;
        break;
    case 'SendAll':
        $pgSQL =<<<SQLVAR
SELECT s.`UID`, CRC32(s.`UID`) AS `Hash`, s.`ProspectUID`, s.`Email`,
    COALESCE(s.`FirstName`,'') AS `FirstName`,
    COALESCE(s.`LastName`,'') AS `LastName`
  FROM `wtkProspectStaff` s
    LEFT OUTER JOIN `wtkEmailsSent`e ON e.`OtherUID` = s.`UID` AND e.`EmailUID` = :EmailUID
    INNER JOIN `wtkProspects` p ON p.`UID` = s.`ProspectUID`
  WHERE s.`DoNotContact` = 'N' AND e.`UID` IS NULL
    AND s.`EmailsSent` = :EmailsSent
    AND p.`ProspectStatus` = 'new'
SQLVAR;
        if ($pgTimeZone != ''):
            $pgSQL .= " AND p.`TimeZone` = '$pgTimeZone'";
        endif;
        $pgSQL .= ' GROUP BY s.`ProspectUID`' . "\n";
        $pgSQL .= ' ORDER BY s.`UID` ASC LIMIT 250' . "\n";
    /* testing
        $pgSQL =<<<SQLVAR
SELECT s.`UID`, CRC32(s.`UID`) AS `Hash`, s.`ProspectUID`, s.`Email`,
    COALESCE(s.`FirstName`,'') AS `FirstName`,
    COALESCE(s.`LastName`,'') AS `LastName`
FROM `wtkProspectStaff` s
LEFT OUTER JOIN `wtkEmailsSent`e ON e.`OtherUID` = s.`UID` AND e.`EmailUID` = :EmailUID
WHERE s.`DoNotContact` = 'N'
--  AND e.`UID` IS NULL
  AND s.`EmailsSent` > :EmailsSent
  AND s.`ProspectUID` = 32768
GROUP BY s.`ProspectUID`
ORDER BY s.`UID` ASC LIMIT 1
SQLVAR;
*/
        $pgSqlFilter = array (
            'EmailUID' => $pgEmailUID,
            'EmailsSent' => 0
        );
        $pgSQL = wtkSqlPrep($pgSQL);
        $pgPDO = $gloWTKobjConn->prepare($pgSQL);
        $pgPDO->execute($pgSqlFilter);
        $pgUpdSQL =<<<SQLVAR
UPDATE `wtkProspectStaff`
  SET `EmailsSent` = (`EmailsSent` + 1)
WHERE `UID` = :UID
SQLVAR;
        $pgUpdProSQL =<<<SQLVAR
UPDATE `wtkProspects`
  SET `ProspectStatus` = 'email'
WHERE `UID` = :ProUID AND `ProspectStatus` = 'new'
SQLVAR;
        $pgCnt = 0;
        $pgUpdSqlFilter = array('UID' => 0);
        $pgProFilter = array('ProUID' => 0);
        $pgList = '';
        while ($pgRow = $pgPDO->fetch(PDO::FETCH_ASSOC)):
            $pgCnt ++;
            $pgToEmail = $pgRow['Email'];
            $pgUserUID = $pgRow['UID'];
            $pgUpdSqlFilter['UID'] = $pgUserUID;
            $pgSaveArray['OtherUID'] = $pgUserUID;
            $pgBody = wtkReplace($pgEmailBody, '@FirstName@', $pgRow['FirstName']);
            $pgBody = wtkReplace($pgBody, '@LastName@', $pgRow['LastName']);
            $pgBody = wtkReplace($pgBody, '@hash@', $pgRow['Hash']);
            $pgTmp = wtkNotifyViaEmail($pgSubject, $pgBody, $pgToEmail, $pgSaveArray,'','emailSales2.htm');
            wtkSqlExec($pgUpdSQL, $pgUpdSqlFilter);
            $pgProspectUID = $pgRow['ProspectUID'];
            $pgProFilter['ProUID'] = $pgProspectUID;
            wtkSqlExec($pgUpdProSQL, $pgProFilter);
            if ($pgCnt < 20):
                if (strlen($pgToEmail) > 18):
                    $pgList .= '<div class="col m4 s6">';
                else:
                    $pgList .= '<div class="col m3 s4">';
                endif;
                $pgList .= $pgUserUID . ': ' . $pgToEmail . '</div>' . "\n";
//                $pgList .= $pgToEmail . '</div>' . "\n";
            endif;
        endwhile;
        $pgAddS = 's';
        if ($pgCnt > 20):
            $pgList .= '<div class="col m3 s4">and more...</div>' . "\n";
        elseif ($pgCnt == 1):
            $pgAddS = '';
        endif;
        $pgForm  = wtkFormHidden('id', $gloRNG);
//        $pgForm .= wtkFormHidden('Mode', 'SendOne');
        $pgPageTime = round(microtime(true) - $gloPageStart,4);
        $pgHtm =<<<htmVAR
<br>
<div class="container">
    <div class="card bg-second">
        <div class="card-content">
    	  <h3>"$pgSubject" email sent to:</h3><br>
          <form id="FemailResults" name="FemailResults">
          $pgForm
          </form>
          <div class="row">
              $pgList
          </div>
          <div class="center">
              <a class="btn" onclick="JavaScript:ajaxGo('emailProspects','$pgMarketingCampaign','SendAll')">Bulk Email</a>
          </div>
        </div>
    	<div class="card-action">Finished sending $pgCnt email$pgAddS in $pgPageTime seconds.</div>
    </div>
</div>
htmVAR;
        break;
    default: // View
        $pgSQL =<<<SQLVAR
SELECT CRC32(s.`UID`) AS `Hash`, s.`Email`,
    COALESCE(s.`FirstName`,'') AS `FirstName`,
    COALESCE(s.`LastName`,'') AS `LastName`
 FROM `wtkProspectStaff` s
WHERE s.`UID` = :UID
SQLVAR;
        $pgSqlFilter = array('UID' => $gloId );
        wtkSqlGetRow($pgSQL, $pgSqlFilter);
        if ($pgMarketingCampaign == 'sales5'):
            $pgBody = wtkLoadInclude(_RootPATH . 'wtk/htm/emailSales2.htm');
        else:
            $pgBody = wtkLoadInclude(_RootPATH . 'wtk/htm/emailSales.htm');
        endif;
        $pgBody = wtkReplace($pgBody, '@wtkContent@', $pgEmailBody);
        $pgBody = wtkReplace($pgBody, '@FirstName@', wtkSqlValue('FirstName'));
        $pgBody = wtkReplace($pgBody, '@LastName@', wtkSqlValue('LastName'));
        $pgBody = wtkReplace($pgBody, '@email@', wtkSqlValue('Email')); // urlencode(trim($fncEmail)));
        $pgBody = wtkReplace($pgBody, '@hash@', wtkSqlValue('Hash'));
        $pgBody = wtkTokenToValue($pgBody);
        $pgHtm  = $pgBody . "\n";
        break;
endswitch;
$pgHtm = wtkReplace($pgHtm, 'btn  btn', 'btn btn');

echo $pgHtm;
exit;
?>
