<?PHP
$pgSecurityLevel = 90;
if (!isset($gloConnected)):
    define('_RootPATH', '../');
    require('../wtk/wtkLogin.php');
endif;

$pgSQL =<<<SQLVAR
SELECT `UID`, `ViewOrder`, `SecurityLevel`,
    `RptType`, `RptName`, `RptNotes`, `RptSelect`, `RptSelectEnd`,
    `SelTableName`, `SelValueColumn`, `SelDisplayColumn`, `SelWhere`,
    `AlignCenter`, `AlignRight`, `SortableCols`,
    `TotalCols`, `TotalMoneyCols`, `FieldSuppress`, `AddLink`, `EditLink`,
    `TestMode`, `HideFooter`, `URLredirect`,
    `StartDatePrompt`, `EndDatePrompt`, `DaysAgo`, `GraphRpt`
FROM `wtkReports` WHERE `UID` = ?
 AND `DelDate` IS NULL
SQLVAR;
$pgSQL  = wtkSqlPrep($pgSQL);
if ($gloWTKmode != 'ADD'):
    $gloForceRO = wtkPageReadOnlyCheck('/admin/reportEdit.php', $gloId);
    wtkSqlGetRow($pgSQL, [$gloId]);
endif;

$pgHtm =<<<htmVAR
<div class="container">
    <h4>SQL Report Wizard</h4><br>
    <div class="card content b-shadow">
        <form id="wtkForm" name="wtkForm" method="POST">
            <span id="formMsg" class="red-text">$gloFormMsg</span>
            <div class="row">
htmVAR;

$pgHtm .= wtkFormText('wtkReports', 'RptName', 'text', 'Report Name');

$pgSQL  = "SELECT `LookupValue`, `LookupDisplay` FROM `wtkLookups` WHERE `LookupType` = 'SecurityLevel' ORDER BY `LookupValue` ASC";
$pgHtm .= wtkFormSelect('wtkReports', 'SecurityLevel', $pgSQL, [], 'LookupDisplay', 'LookupValue','','m3 s6');

$pgSQL  = "SELECT `LookupValue`, `LookupDisplay` FROM `wtkLookups` WHERE `LookupType` = 'RptType' ORDER BY `LookupDisplay` ASC";
$pgHtm .= wtkFormSelect('wtkReports', 'RptType', $pgSQL, [], 'LookupDisplay', 'LookupValue','Type', 'm3 s6');

$pgHtm .= wtkFormText('wtkReports', 'ViewOrder','number','', 'm4 s6');

$pgValues = array(
    'checked' => 'Y',
    'not' => 'N'
);
$pgHtm .= wtkFormCheckbox('wtkReports', 'HideFooter', '', $pgValues, 'm4 s6');
$pgHtm .= wtkFormCheckbox('wtkReports', 'TestMode', '', $pgValues, 'm4 s6');

$pgHtm .= wtkFormTextArea('wtkReports', 'RptNotes', 'Description');
$pgHtm .= wtkFormText('wtkReports', 'URLredirect','text','URL Redirect (if entered below is ignored)');
$pgHtm .= wtkFormTextArea('wtkReports', 'RptSelect', 'SQL for Report');
$pgHtm .= wtkFormTextArea('wtkReports', 'RptSelectEnd', 'SQL after WHERE (GROUP BY, ORDER BY)');

$pgHtm .=<<<htmVAR
</div>
<div class="row">
    <h5>Date Filter Options</h5>
    <div class="col s12">
        <p>Fill any of the below and that filter option will appear.</p>
    </div>
htmVAR;

$pgHtm .= wtkFormText('wtkReports', 'StartDatePrompt','text','First Date Prompt','m6 s12','N', 'access value as @StartDate@ in your SQL');
$pgHtm .= wtkFormText('wtkReports', 'EndDatePrompt','text','Second Date Prompt','m6 s12','N','access value as @EndDate@ in your SQL');
$pgHtm .= '<div class="input-field col m7 s12"><p>Use above filters or "How many days" but not both.</p></div>' . "\n";
$pgHtm .= wtkFormText('wtkReports', 'DaysAgo','number','How many days before today','m5 s12','N','access value as @DaysPast@ in your SQL');

$pgHtm .=<<<htmVAR
</div>
<div class="row">
    <h5>Drop-Table Filter Option</h5>
    <div class="col s12">
        <p>You can add a table to filter results by.  Add more tables in Lookups.</p>
    </div>
htmVAR;

$pgSQL  = "SELECT `LookupValue`, `LookupDisplay` FROM `wtkLookups` WHERE `LookupType` = ? ORDER BY `LookupDisplay` ASC";
$pgHtm .= wtkFormSelect('wtkReports', 'SelTableName', $pgSQL, ['SelTableName'], 'LookupDisplay', 'LookupValue', 'Data Table Filter', 'm4 s12', 'Y');
$pgSQL  = "SELECT `LookupValue`, `LookupDisplay` FROM `wtkLookups` WHERE `LookupType` = ? ORDER BY `LookupDisplay` ASC";
$pgHtm .= wtkFormSelect('wtkReports', 'SelValueColumn', $pgSQL, ['SelValueColumn'], 'LookupDisplay', 'LookupValue', 'Data ID Column', 'm2 s12', 'Y');
$pgHtm .= wtkFormTextArea('wtkReports', 'SelDisplayColumn', 'Data Display Column', 'm6 s12');
$pgHtm .=<<<htmVAR
    <div class="input-field col s12">
        <span class="helper-text" style="margin-top:-27px">
            Access value chosen by users from <b>Data Id</b> as @DropFilter@ in your SQL above.
        </span>
    </div>
htmVAR;
$pgHtm .= wtkFormText('wtkReports', 'SelWhere', 'text', 'Where Filter', 'm12');
$pgHtm .= '</div>' . "\n";

$pgHtm .= '<div class="row">' . "\n";
$pgHtm .= '<h5>Special Browse Affects</h5><br>' . "\n";
$pgHtm .= wtkFormText('wtkReports', 'AddLink');
$pgHtm .= wtkFormText('wtkReports', 'EditLink');
$pgHtm .= wtkFormTextArea('wtkReports', 'AlignCenter', 'Align Center', 'm6 s12');
$pgHtm .= wtkFormTextArea('wtkReports', 'AlignRight', 'Align Right', 'm6 s12');
$pgHtm .= wtkFormTextArea('wtkReports', 'FieldSuppress','Suppress Columns','m6 s12');

$pgHtm .= wtkFormTextArea('wtkReports', 'SortableCols', 'Sortable Columns','m6 s12');
$pgHtm .= wtkFormTextArea('wtkReports', 'TotalCols', 'Total Columns', 'm6 s12');
$pgHtm .= wtkFormTextArea('wtkReports', 'TotalMoneyCols', 'Total Money Columns', 'm6 s12');

$pgHtm .=<<<htmVAR
</div>
<div class="row">
    <h5>Charting Option</h5>
    <div class="col s12">
        <p>If your report has a description as the first column and the
        rest of the columns are graphable values, then you can add graphs.</p>
    </div>
htmVAR;

$pgHtm .= wtkFormCheckbox('wtkReports', 'GraphRpt', 'Add Graphs to Report?', $pgValues, 'm6 s12 offset-m3 center');
$pgHtm .= '</div><br>' . "\n";
$pgHtm .= '<div class="row">' . "\n";

$pgHtm .= wtkFormHidden('wtkGoToURL', '../../admin/reportList.php');
$pgHtm .= wtkFormHidden('ID1', $gloId);
$pgHtm .= wtkFormHidden('UID', wtkEncode('UID'));
wtkFormPrepUpdField('wtkReports', 'LastModByUserUID', 'text');
$pgHtm .= wtkFormHidden('wtkwtkReportsLastModByUserUID', $gloUserUID);
$pgHtm .= wtkFormHidden('wtkMode', $gloWTKmode);
$pgHtm .= wtkUpdateBtns('reportList', 'wtkForm','/wtk/lib/mobSave','Y') . "\n";
$pgHtm .= wtkFormWriteUpdField();

$pgHtm .=<<<htmVAR
            </div>
        </form>
    </div>
</div>
htmVAR;
echo $pgHtm;
exit;
?>
