<?PHP
$pgSecurityLevel = 90;
define('_RootPATH', '../');
require('../wtk/wtkLogin.php');
if ($gloId == ''):
    $gloId = wtkGetGet('id'); // for View call
endif;

$pgSQL =<<<SQLVAR
SELECT `Subject`, `EmailBody` FROM `wtkEmailTemplate`
 WHERE `UID` = :UID
SQLVAR;
$pgSqlFilter = array (
    'UID' => $gloId
);
wtkSqlGetRow($pgSQL, $pgSqlFilter);

$pgSubject = wtkSqlValue('Subject');
$pgEmailBody = wtkSqlValue('EmailBody');
$pgSubject = wtkReplace($pgSubject, '@CompanyName@', $gloCoName);
$pgSaveArray = array (
    'EmailUID' => $gloId,
    'FromUID' => 0
);

$pgMode = wtkGetParam('Mode');
$pgHtm = '';
switch ($pgMode):
    case 'OneUser':
        $pgSQL =<<<SQLVAR
SELECT u.`UID` AS `UserUID`, CONCAT(u.`FirstName`, ' ', COALESCE(u.`LastName`,'')) AS `User`
  FROM `wtkUsers` u
    LEFT OUTER JOIN `wtkEmailsSent`e ON e.`SendToUserUID` = u.`UID` AND e.`EmailUID` = :EmailUID
  WHERE e.`UID` IS NULL
    AND u.`OptInEmails` = :OptInEmails
  ORDER BY u.`FirstName` ASC, u.`LastName` ASC
SQLVAR;
        $pgSQL  = wtkSqlPrep($pgSQL);
        $pgSqlFilter = array (
            'EmailUID' => $gloId,
            'OptInEmails' => 'Y'
        );
        $gloWTKmode = 'ADD';
        $pgForm  = wtkFormSelect('wtkUsers', 'UID', $pgSQL, $pgSqlFilter, 'User', 'UserUID', 'Pick User', 's12');
        $pgForm  = wtkReplace($pgForm, 'class="input-field col s12"','id="UserUIDDIV" class="input-field col s12"');
        $pgForm .= wtkFormHidden('id', $gloId);
        $pgForm .= wtkFormHidden('Mode', 'SendOne');
        $pgForm .= wtkFormWriteUpdField();
        $pgHtm =<<<htmVAR
<div class="modal-content">
    <p>Choose who to send "<strong>$pgSubject</strong>" email to:</p>
    <form id="FemailResults" name="FemailResults" class="card content b-shadow">
        <div class="switch">
            <label>To User
                <input type="checkbox" value="Email" id="UserOrEmail" name="UserOrEmail" onclick="JavaScript:showEmailOrUser(this.value)">
                <span class="lever"></span>
                Non-User Email
            </label>
        </div>
        <br><br>
        <div class="row">
            $pgForm
            <div id="ToEmailDIV" class="input-field col s12 hide">
                <input id="ToEmail" name="ToEmail" type="email" class="validate" onchange="JavaScript:wtkValidate(this,'EMAIL')">
                <label for="ToEmail">Email</label>
            </div>
        </div>
    </form>
</div>
<div id="modFooter" class="modal-footer right">
    <a class="btn-small black b-shadow waves-effect waves-light modal-close" onclick="JavaScript:wtkFixSideNav()">Close</a> &nbsp;&nbsp;
    <a class="btn-primary btn-small b-shadow waves-effect waves-light" onclick="JavaScript:adminValidateEmail()">Send</a>
</div>
<script type="text/javascript">
function showEmailOrUser(){
    if ($('#UserOrEmail').is(':checked')) {
        $('#UserUIDDIV').addClass('hide');
        $('#ToEmailDIV').removeClass('hide');
    } else {
        $('#UserUIDDIV').removeClass('hide');
        $('#ToEmailDIV').addClass('hide');
    }
}
function adminValidateEmail(){
    var fncSendEmail = 'N';
    if ($('#UserOrEmail').is(':checked')) {
        let fncToEmail = $('#ToEmail').val();
        if (fncToEmail == ''){
            wtkAlert('Enter an email address to send to');
        } else {
            if (isValidEmail(fncToEmail)) {
                fncSendEmail = 'Y';
            } else {
                wtkAlert('Email address is not valid');
            }
        }
    } else {
        fncSendEmail = 'Y';
    }
    if (fncSendEmail == 'Y'){
        modalSave('sendEmail','emailResults');
        let fncId = document.getElementById('modalWTK');
        let fncModal = M.Modal.getInstance(fncId);
        fncModal.close();
        M.toast({html: 'The email has been sent.', classes: 'green rounded'});
    }
}
</script>
htmVAR;
        break;
    case 'SendOne':
        $pgUserOrEmail = wtkGetPost('UserOrEmail');
        if ($pgUserOrEmail == 'Email'):
            $pgToEmail = wtkGetPost('ToEmail');
        else:
            $pgUserUID = wtkGetPost('wtkwtkUsersUID');
            $pgToEmail = wtkSqlGetOneResult('SELECT `Email` FROM `wtkUsers` WHERE `UID` = ?', [$pgUserUID]);
        endif;
        $pgEmailBody = wtkReplace($pgEmailBody, '@email@', $pgToEmail);
        $pgTmp = wtkNotifyViaEmail($pgSubject, $pgEmailBody, $pgToEmail, $pgSaveArray);
        $pgHtm .= '<span class="chip green white-text">Sent "' . $pgSubject . '" email to: ' . $pgToEmail . '</span>';
        break;
    case 'Test':
        $pgTmp = wtkNotifyViaEmail($pgSubject, $pgEmailBody, $gloTechSupport, $pgSaveArray);
        // 2VERIFY review in Dark mode: style="background: #3c3838 !important"
        $pgHtm .=<<<htmVAR
<div class="modal-content">
    <h2>Email Sent</h2>
    <br>
    <p>Test email sent to $gloTechSupport</p>
    <p><strong>Subject:</strong> TST: $pgSubject</p>
</div>
<div id="modFooter" class="modal-footer right">
    <a class="btn $gloIconSize modal-close waves-effect" onclick="JavaScript:wtkFixSideNav()">Close</a>
</div>
htmVAR;
        break;
    case 'VerifyBulk':
        $pgSQL =<<<SQLVAR
SELECT COUNT(*)
  FROM `wtkUsers` u
    LEFT OUTER JOIN `wtkEmailsSent`e ON e.`SendToUserUID` = u.`UID` AND e.`EmailUID` = :EmailUID
  WHERE e.`UID` IS NULL AND u.`OptInEmails` = :OptInEmails
SQLVAR;
        $pgSqlFilter = array (
            'EmailUID' => $gloId,
            'OptInEmails' => 'Y'
        );
        $pgCount = wtkSqlGetOneResult($pgSQL, $pgSqlFilter);
        if ($pgCount == 0):
            $pgForm = '';
            $pgList = '';
            $pgSaveBtn = '';
            $pgFooter =<<<htmVAR
 All users already received this email template. &nbsp;&nbsp;
  <a class="btn-small black b-shadow waves-effect waves-light modal-close">Cancel</a>
 &nbsp;&nbsp;
htmVAR;
        else:
            $pgSaveBtn = ' &nbsp;&nbsp;' . "\n";
            $pgFormattedCount = number_format($pgCount);
            $pgFooter =<<<htmVAR
    <div class="left" style="margin-left: 27px"><strong>Are you ready to send $pgFormattedCount emails?</strong></div>
    <div class="right">
        <a class="btn-small black b-shadow waves-effect waves-light modal-close">Cancel</a>
         &nbsp;&nbsp;
         <a class="btn-primary btn-small b-shadow waves-effect waves-light" onclick="JavaScript:modalSave('sendEmail','emailResults')">Send</a>
         &nbsp;&nbsp;
    </div>
htmVAR;

            $pgSQL =<<<SQLVAR
SELECT u.`UID`, u.`Email`
  FROM `wtkUsers` u
    LEFT OUTER JOIN `wtkEmailsSent`e ON e.`SendToUserUID` = u.`UID` AND e.`EmailUID` = :EmailUID
  WHERE e.`UID` IS NULL
    AND u.`OptInEmails` = :OptInEmails
  ORDER BY u.`UID` ASC LIMIT 20
SQLVAR;
            $pgSqlFilter = array (
                'EmailUID' => $gloId,
                'OptInEmails' => 'Y'
            );
            $pgSQL = wtkSqlPrep($pgSQL);
            $pgPDO = $gloWTKobjConn->prepare($pgSQL);
            $pgPDO->execute($pgSqlFilter);
            $pgCnt = 0;
            $pgList = '';
            while ($pgRow = $pgPDO->fetch(PDO::FETCH_ASSOC)):
                $pgCnt ++;
                $pgToEmail = $pgRow['Email'];
                $pgUserUID = $pgRow['UID'];
                if ($pgCnt < 20):
                    $pgList .= '<div class="col m4 s6">';
                    $pgList .= $pgToEmail . '</div>' . "\n";
                else:
                    $pgList .= '<div class="col m8 s12"><strong>and ' . number_format($pgCount - 20) . ' more emails</strong></div>' . "\n";
                endif;
            endwhile;
            $pgForm  = wtkFormHidden('id', $gloId);
            $pgForm .= wtkFormHidden('Mode', 'SendAll');
        endif; // $pgCount > 0

        $pgHtm =<<<htmVAR
<div class="modal-content">
    <div class="card bg-second">
        <div class="card-content">
            <h5>"$pgSubject" email will be sent to:</h5>
            <form id="FemailResults" name="FemailResults" class="hide">
              $pgForm
            </form>
            <div class="row">
              $pgList
            </div>
            <div id="emailResults"></div>
            <p>Note that anyone who previuosly received this email template
            is excluded and will not receive the email again.</p>
        </div>
    </div>
</div>
<div id="modFooter" class="modal-footer">
    $pgFooter
</div>
htmVAR;
        break;
    case 'SendAll':
        session_write_close();  // so rest of website still works
        $pgSQL =<<<SQLVAR
SELECT u.`UID`, u.`Email`
  FROM `wtkUsers` u
    LEFT OUTER JOIN `wtkEmailsSent`e ON e.`SendToUserUID` = u.`UID` AND e.`EmailUID` = :EmailUID
  WHERE e.`UID` IS NULL
    AND u.`OptInEmails` = :OptInEmails
  ORDER BY u.`UID` ASC
SQLVAR;
        $pgSqlFilter = array (
            'EmailUID' => $gloId,
            'OptInEmails' => 'Y'
        );
        $pgSQL = wtkSqlPrep($pgSQL);
        $pgPDO = $gloWTKobjConn->prepare($pgSQL);
        $pgPDO->execute($pgSqlFilter);
        $pgCnt = 0;
        $pgList = '';
        $gloEmailFromAddress = $gloEmailBulkAddress;
        $gloBulkEmailing = true;
        while ($pgRow = $pgPDO->fetch(PDO::FETCH_ASSOC)):
            $pgCnt ++;
            $pgToEmail = $pgRow['Email'];
            $pgUserUID = $pgRow['UID'];
            $pgSaveArray['ToUID'] = $pgUserUID;
// 2ENHANCE can switch from this method of one-at-a-time to changing
//  to this method: https://github.com/PHPMailer/PHPMailer/blob/master/examples/mailing_list.phps
            $pgTmp = wtkNotifyViaEmail($pgSubject, $pgEmailBody, $pgToEmail, $pgSaveArray);
        endwhile;
        $pgAddS = '';
        if ($pgCnt > 1):
            $pgAddS = 's';
        endif;
        $pgForm  = wtkFormHidden('id', $gloId);
        $pgForm .= wtkFormHidden('Mode', 'SendOne');
        $pgPageTime = round(microtime(true) - $gloPageStart,4);
        $pgHtm =<<<htmVAR
<br>
<div class="card blue">
    <div class="card-content">
	  <h5>Finished sending $pgCnt email$pgAddS in $pgPageTime seconds.</h5>
    </div>
</div>
<script type="text/javascript">
$('#modFooter').addClass('hide');
</script>
htmVAR;
        break;
    default: // View
    //  $pgHtm = wtkLoadInclude(_RootPATH . 'wtk/htm/email' . $gloDarkLight . '.htm');
        $pgHtm = wtkLoadInclude(_RootPATH . 'wtk/htm/emailLight.htm');
        if ($gloId == 3):
            $pgHtm = wtkReplace($pgHtm, '@wtkContent@', $pgEmailBody);
        else:
            $pgHtm = wtkReplace($pgHtm, '@wtkContent@', nl2br($pgEmailBody));
        endif;
        $pgHtm = wtkTokenToValue($pgHtm);
        $pgHtm = wtkReplace($pgHtm, '@email@', trim($gloTechSupport)); // urlencode(trim($fncEmail)));
        $pgHtm = wtkReplace($pgHtm, '@Header@', $pgSubject);
        $pgHtm = wtkReplace($pgHtm, '@FirstName@', 'John');
        $pgHtm = wtkReplace($pgHtm, '@LastName@', 'Smith');
        break;
endswitch;
$pgHtm = wtkReplace($pgHtm, 'btn  btn', 'btn btn');

echo $pgHtm;
exit;
?>
