var pgFileSizeOK = 'Y';
var pgFileToUpload = 'N';
let pgFileName = '';
let pgFileSize = '';

function wtkFileChanged(){
    let fncFileTest = document.getElementById('wtkUpload').files[0];
    if (fncFileTest) {
       pgFileName = fncFileTest.name;
       pgFileSize = fncFileTest.size;
       let fncMsg = 'file size: ' + formatBytes(pgFileSize);
       if (pgFileSize < gloMaxFileSize){
           pgFileSizeOK = 'Y';
       } else {
           wtkAlert('File is too large to upload<br>Maximum size allowed is ' + formatBytes(gloMaxFileSize) + '<br>File will not be uploaded.');
           pgFileSizeOK = 'N';
           fncMsg = (fncMsg + '<br><a href="https://resizeyourimage.com" target="_blank">(resize your image)</a>');
       }
       if (elementExist('wtkfPhoto') == false) {
           $('#uploadFileSize').html(fncMsg);
       }
       wtkDebugLog('wtkFileChanged: pgFileName = ' + pgFileName + '; pgFileSize = ' + pgFileSize + '; pgFileSizeOK = ' + pgFileSizeOK);
       if (elementExist('wtkwtkFilesDescription')) {
           if ($('#wtkwtkFilesDescription').val() == '') {
               fncFileName = pgFileName.replace(/\.[^/.]+$/, '');
               fncFileName = fncFileName.replaceAll('-',' ');
               fncFileName = fncFileName.replaceAll('_',' ');
               $('#wtkwtkFilesDescription').val(fncFileName);
               $('label[for="wtkwtkFilesDescription"]').addClass('active');
           }
       }
       wtkProcessFile(fncFileTest);
   } else {
       wtkDebugLog('wtkFileChanged: fncFileTest failed');
   }
} // wtkFileChanged

function wtkProcessFile(fncFile) {
    wtkDebugLog('wtkProcessFile');
    // we define fr as a new instance of FileReader
    let fr = new FileReader();
    fr.readAsDataURL(fncFile);
    // Handle progress, success, and errors
    fr.onerror = wtkfErrorHandler;
    fr.onabort = () => wtkChangeStatus('File process aborted!');
    fr.onloadstart = () => wtkChangeStatus('Start Loading');
    fr.onload = wtkLoaded;
    // Here you can perform some operations on the data asynchronously
    fr.onprogress = wtkSetProgress;
} // wtkProcessFile

 // Updates the value of the progress bar
function wtkSetProgress(e) {
    wtkDebugLog('wtkSetProgress');
    if ($('#photoProgressDIV').hasClass('hide')) {
        $('#photoProgressDIV').removeClass('hide');
    }
    let loadingPercentage = ((100 * e.loaded) / e.total);
    document.getElementById('photoProgress').style.width = (loadingPercentage + '%');
}

function wtkChangeStatus(fncStatus){
    $('#uploadStatus').text('Upload Progress: ' + fncStatus);
}

function wtkLoaded(e){
    wtkDebugLog('wtkLoaded top');
    wtkChangeStatus('File load complete');
    pgFileToUpload = 'Y';
//  console.log(e);
    let fr = e.target;
    var fncImg = fr.result;
    if (elementExist('imgPreview')) {
        if (pgFileSize < gloMaxFileSize){
            pgFileSizeOK = 'Y';
            let fncShowImg = document.querySelector('#imgPreview');
            fncShowImg.src = fncImg;
        }
        if (elementExist('wtkfRefresh')) {
            let fncRefresh = $('#wtkfRefresh').val();
            if (fncRefresh != ''){
                wtkDebugLog('wtkfLoaded: fncRefresh = ' + fncRefresh);
                if (elementExist(fncRefresh)) {
                    let fncShowImg2 = document.querySelector('#' + fncRefresh);
                    fncShowImg2.src = fncImg;
                }
            }
        }
    } else {
        if (elementExist('filePreview')) {
            let fncShowFile = document.querySelector('#filePreview');
            fncShowFile.href = fncImg;
            if ($('#filePreview').hasClass('hide')) {
                $('#filePreview').removeClass('hide');
            }
        }
    }
    if (elementExist('phoneSideBar')) {
        let elems = document.querySelectorAll('.sidenav');
        M.Sidenav.init(elems, {edge:'right'});
    }
    if (pgFileSize < gloMaxFileSize){
        if (elementExist('wtkfPhoto')) {
            if ($('#wtkfPhotoDIV').hasClass('hide')) {
                $('#wtkfPhotoDIV').removeClass('hide');
            }
            if ($('#wtkfSaveBtn').hasClass('hide')) {
                $('#wtkfSaveBtn').removeClass('hide');
            }
            if ($('#wtkf2btns').hasClass('hide')) {
                $('#wtkf2btns').removeClass('hide');
            }
        }
    }
    document.getElementById('photoProgress').style.width = '100%';
    $('#photoProgressDIV').fadeOut(720);
    $('#uploadStatus').fadeOut(720);
    if (elementExist('wtkfUploadBtn')) {
        $('#wtkfUploadBtn').removeClass('hide');
    }
    setTimeout(function() {
        $('#uploadStatus').text('');
        document.getElementById('photoProgress').style.width = '0%';
        $('#photoProgressDIV').addClass('hide');
        $('#photoProgressDIV').fadeIn(1);
        $('#uploadStatus').fadeIn(1);
        if (elementExist('wtkfPhoto')) {
            $('#wtkfDelBtn').addClass('hide');
        } else {
            let fncPastImg = $('#wtkfOrigPhoto').val();
            if (fncPastImg != '/wtk/imgs/noPhotoSmall.gif') {
                if ($('#wtkfDelBtn').hasClass('hide')) {
                    $('#wtkfDelBtn').removeClass('hide');
                }
            }
        }
    }, 720);
} // wtkLoaded

function wtkfErrorHandler(e){
    wtkDebugLog('wtkfErrorHandler top');
    wtkfChangeStatus("Error: " + e.target.error.name);
}

function wtkfFileUpload() {
   wtkDebugLog('wtkfFileUpload top');
   let fr = new FileReader();
   let xhr = new XMLHttpRequest();

   if (elementExist('wtkfPhoto') == false) {
       xhr.upload.addEventListener("progress", function(e) {
           if (e.lengthComputable) {
               let percentage = Math.round((e.loaded * 100) / e.total);
               $('#uploadProgress').text(percentage);
           }
       }, false);

       xhr.upload.addEventListener("load", function(e) {
           $('#uploadProgress').text(100);
       }, false);
   }

   xhr.open("POST", "/wtk/fileUpload.php");
   xhr.overrideMimeType('text/plain; charset=x-user-defined-binary');
   //  xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");

   let fncRefresh = $('#wtkfRefresh').val();
   xhr.onreadystatechange = function() {
       if (elementExist('wtkfUploadBtn')) {
          $('#uploadFileDIV').addClass('hide');
          if (elementExist('uploadFileBtn')) {
             $('#uploadFileBtn').removeClass('hide');
          }
       }

       if (this.readyState == 4 && this.status == 200) {
           pgFileToUpload = 'N';
           if (elementExist('wtkfRefreshDIV')) {
               let fncRefreshDIV = $('#wtkfRefreshDIV').val();
               if (fncRefreshDIV != ''){
                   ajaxFillDiv(fncRefreshDIV,'photos','displayFileDIV',$('#ID1').val());
                   $('#wtkUpload').val();
               }
               if (elementExist('wtkfUploadBtn')) {
                   $('#wtkfUploadBtn').addClass('hide');
               }
           }
           if (fncRefresh != ''){
               wtkDebugLog('fncRefresh = ' + fncRefresh);
               let fncJSON = JSON.parse(this.responseText);
               let fncImg = fncJSON.path + fncJSON.fileName;
               if (elementExist(fncRefresh)) {
                   let fncShowImg = document.querySelector('#' + fncRefresh);
                   fncShowImg.src = fncImg;
               }
               if (elementExist('wtkfPhoto')) {
                  $('#wtkfOrigPhoto').val(fncImg);
               }
           }
       }
   };

   fr.onload = function(evt) {
//       console.log(evt);
       let fncPath = $('#wtkfColPath').val();
       if (typeof pgMPAvsSPA === 'undefined') {
           var pgMPAvsSPA = 'MPA';
       }

       let data={};
       if (elementExist('imgMode')) {
           data.mode = $('#imgMode').val();
       } else {
           data.mode = $('#wtkMode').val();
       }
       if (elementExist('imgTable')) {
           data.t = $('#imgTable').val();
       } else {
           data.t = $('#T').val();
       }
       if (elementExist('tabRel')) {
           data.tabRel=$('#tabRel').val();
       } else {
           data.tabRel='';
       }
       data.colPath=fncPath;
       data.wtkDesign=pgMPAvsSPA;
       data.colFile=$('#wtkfColFile').val();
       data.uid=$('#UID').val();
       if (elementExist('UserUID')) {
           data.userUID=$('#UserUID').val();
       } else {
           data.userUID='';
       }
       if (elementExist('ParentUID')) {
           data.parentUID=$('#ParentUID').val();
       }
       data.id=$('#ID1').val();
       data.path=$('#wtkfPath').val();
       data.fileName=pgFileName;
       data.del=$('#wtkfDelete').val();
       data.file=evt.target.result;
       data.s='~369+success+BIG!winning+WTK+hope+Today~432~';
       let string = JSON.stringify(data);
       xhr.send(string);
   };

   let upFile = document.getElementById('wtkUpload').files[0];
   if (typeof upFile !== 'undefined') {
      fr.readAsDataURL(upFile);
   }
} // wtkfFileUpload

function wtkfDelFile() {
    fncTbl = $('#T').val();
    fncColPath = $('#wtkfColPath').val();
    fncColFile = $('#wtkfColFile').val();
    fncUID = $('#UID').val();
    fncId = $('#ID1').val();
    fncPath = $('#wtkfPath').val();
    fncDel = $('#wtkfDelete').val();
    if (typeof pgApiKey === 'undefined') {
        pgApiKey = '';
    }
    $.ajax({
        type: "POST",
        url:  '/wtk/ajxDelFile.php',
        data: { apiKey: pgApiKey, colPath: fncColPath, colFile: fncColFile, t: fncTbl,
                uid: fncUID, id: fncId, path: fncPath, del: fncDel, wtkDesign: pgMPAvsSPA},
        success: function(data) {
            if (elementExist('imgPreview')) {
                var fncShowImg = document.querySelector('#imgPreview');
                fncShowImg.src = '/wtk/imgs/noPhotoSmall.gif';
            } else {
                if (elementExist('filePreview')) {
                    var fncShowFile = document.querySelector('#filePreview');
                    fncShowFile.href = '';
                    $('#filePreview').addClass('hide');
                }
            }
            $('#wtkfDelBtn').addClass('hide');
            $('#wtkfAddBtn').removeClass('hide');
            if (elementExist('wtkfPhoto')) {
                $('#wtkfPhotoDIV').addClass('hide');
                $('#wtkf2btns').removeClass('hide');
            }
            $('#wtkfOrigPhoto').val('/wtk/imgs/noPhotoSmall.gif');
            pgFileToUpload = 'N';
            $('#uploadFileSize').text('');
            if (elementExist('FileUploaded')) {
                $('#FileUploaded').val('N');
            }
        }
    })
} // wtkfDelFile

function wtkfRevertImg() {
    let fncShowImg = document.querySelector('#imgPreview');
    let fncPastImg = $('#wtkfOrigPhoto').val();
    fncShowImg.src = fncPastImg;
    if (fncPastImg == '/wtk/imgs/noPhotoSmall.gif') {
        $('#wtkfPhotoDIV').addClass('hide');
    } else {
        $('#wtkf2btns').addClass('hide');
        $('#wtkfAddBtn').addClass('hide');
        $('#wtkfDelBtn').removeClass('hide');
    }
    pgFileToUpload = 'N';
} // wtkfRevertImg

function wtkfPhoto() {
    wtkDebugLog('wtkfPhoto');
    // used for single-click upload without needing full form submission
    // called from PHP function: wtkFileUpload
    wtkfFileUpload();
    $('#wtkfPhotoDIV').addClass('hide');
    pgFileToUpload = 'N';
}

function wtkShowImageUpload(){
    $('#uploadFileBtn').addClass('hide');
    $('#uploadFileDIV').removeClass('hide');
    $('#uploadFileSize').text('');
    $('#uploadProgress').text('');
    if (elementExist('imgPreview')) {
        var fncShowImg = document.querySelector('#imgPreview');
        fncShowImg.src = '/wtk/imgs/noPhotoSmall.gif';
    }
}// used in conjunction with wtkFormFile PHP function
