<!--
/*
 This file has jQuery and pure Javascript without having any other requirements.
 wtkLibrary.js contains the following functions:
    ajaxGo, ajaxPost, mobAlert, and many more required by Wizards Toolkit
*/
// var wtkBrowseFilter;
const wtkParams = new URLSearchParams(window.location.search);
var pgDebug = 'N';

// below function called in HTML by <body onload >
function wtkStartMaterializeCSS() {
    $(document).ready(function() {
        M.AutoInit();
        let fncTmpVar = $('#pgDebugVar').val();
        if (fncTmpVar == 'Y') {
            pgDebug = 'Y';
        }
        fncTmpVar = $('#pgPathVar').val();
        if (fncTmpVar != undefined) {
            pgPath = fncTmpVar;
        }
        fncTmpVar = $('#pgSiteVar').val();
        if (fncTmpVar != undefined) {
            pgSite = fncTmpVar;
        }
        fncTmpVar = $('#pgMobileAppVar').val();
        if (fncTmpVar != undefined) {
            let fncTest = fncTmpVar.includes('?') ? 'Yes' : 'No';
            if (fncTest == 'Yes') { // fixes strange Xcode bug
                let fncTmpArray = fncTmpVar.split("?");
                pgMobileApp = fncTmpArray[0];
            } else {
                pgMobileApp = fncTmpVar;
            }
        }
        let fncCharCntr = $('#CharCntr').val();
        if (fncCharCntr == 'Y') {
            M.CharacterCounter.init();
            M.CharacterCounter.init(document.querySelectorAll('.char-cntr'));
        }
        fncTmpVar = $('#HasCollapse').val();
        if (fncTmpVar == 'Y') {
            let fncElem = document.querySelectorAll('.collapsible');
            let fncTmp = M.Collapsible.init(fncElem);
        }
        fncTmpVar = $('#HasImage').val();
        if (fncTmpVar == 'Y') {
    //        $('.materialboxed').materialbox();
            let fncElemImg = document.querySelectorAll('.materialboxed');
            let fncTmp2 = M.Materialbox.init(fncElemImg);
            wtkDebugLog('wtkStartMaterializeCSS: HasImage');
        }
        if ($('#HasTooltip').val() == 'Y') {
            let fncOption = {};
            let fncTmp3 = document.querySelectorAll('.tooltipped');
            let fncTmp4 = M.Tooltip.init(fncTmp3, fncOption);
        }
        if ($('#wtkUpload').val() !== undefined) {
            // all File-Upload related functions are in wtkFileUpload.js
            document.getElementById('wtkUpload').addEventListener('change', (e) => {
                wtkFileChanged();
            })
        }
        fncTmpVar = $('#changeLanguage').val();
        if (fncTmpVar != undefined) {
            wtkLangUpdate(fncTmpVar);
        }
        $(".wrapper-load").fadeOut();
        if (typeof wtkMPAstart === "function") {
            wtkMPAstart();
        }
        fncTmpVar = $('#SPArestart').val();
        if (fncTmpVar == 'Y') {
            $('#mainPage').removeClass('hide');
            $('#myNavbar').removeClass('hide');
            $('#loginPage').addClass('hide');
            pgApiKey = $('#apiKeyRestart').val();
            pgSecLevel = $('#secLvlRestart').val();
            pgMPAvsSPA = 'SPA';
        }
        if (elementExist('myEmail')) {
           document.getElementById('myEmail').onchange = function() {
               wtkValidate(this,'EMAIL');
           };
        }
        if (elementExist('wtkwtkUsersEmail')) {
            document.getElementById('wtkwtkUsersEmail').onchange = function() {
                wtkValidate(this,'EMAIL');
            };
        }
    });
} // wtkStartMaterializeCSS

var fncLastIconColor = 'red';
function wtkAlert(fncText, fncHdr = 'Oops!', fncColor = 'red', fncIcon = 'warning') {
    if (fncLastIconColor != fncColor) {
        $('#modIcon').removeClass(fncLastIconColor + '-text');
        $('#modIcon').addClass(fncColor + '-text');
        fncLastIconColor = fncColor;
    }
    $('#modIcon').text(fncIcon);
    let fncId = document.getElementById('modalAlert');
    let fncModal = M.Modal.getInstance(fncId);
    $('#modHdr').text(fncHdr);
    $('#modText').html(fncText);
    fncModal.open();
    wtkDebugLog('mobAlert called: ' + fncText);
} // wtkAlert
function wtkChangeRequired(fncId,fncRequired) {
	let fncTmp = document.getElementById(fncId);
	if (fncRequired == true) {
		fncTmp.setAttribute('required', '');
		wtkDebugLog('changeRequired : set required for ' + fncId);
	} else {
		fncTmp.removeAttribute('required');
		wtkDebugLog('changeRequired : set NOT required for ' + fncId);
	}
}
function wtkDebugLog(fncMsg) {
    if (pgDebug == 'Y') {
        let now = new Date();
        let sec = now.getSeconds();
        let msec = now.getMilliseconds();
        console.log(sec + ':' + msec + ' ' + fncMsg);
        let fncElement = document.getElementById('debugLogDIV');
        if (typeof(fncElement) != 'undefined' && fncElement != null){
            $('#debugLogDIV').append('<br>' + sec + ':' + msec + ' ' + fncMsg);
        }
    } // pgDebug == 'Y'
}
function wtkSaveDebugLog() {
    if ((pgDebug == 'Y') && elementExist('debugLogDIV')) {
        // wait half a second to get additional debug logs
        setTimeout(function() {
            let fncDebugLog = $('#debugLogDIV').html();
            $.ajax({
                type: 'POST',
                url:  '/wtk/ajxSaveJSDebug.php',
                data: { apiKey: pgApiKey, DebugLog: fncDebugLog },
            })
        }, 500);
    }
}
function wtkGetValue(fncIdName) {
    let fncTest = document.getElementById(fncIdName);
    if (fncTest) {
        var fncResult = document.getElementById(fncIdName).value;
    } else {
        var fncResult = '';
    }
    return fncResult;
} // wtkGetValue
function wtkDisableBtn(fncBtnName) {
    if (elementExist(fncBtnName)) {
        $('#' + fncBtnName).attr("disabled", true);
        setTimeout(function() {
            $('#' + fncBtnName).attr("disabled", false);
        }, 3600);
    }
}
function wtkChangeLang(fncLanguage, fncGoTo) {
    pgLanguage = fncLanguage;
    let fncLang = 'English';
    switch (pgLanguage) {
        case 'esp':
            fncLang = 'Spanish';
            break;
    }
    $('#langBtn').text(fncLang);
    $.getJSON('/wtk/setLanguage.php?Lang=' + fncLanguage, function(data) {
        window.location.replace(fncGoTo);
    });
} // wtkChangeLang
function wtkLangUpdate(fncLanguage) {
    pgLanguage = fncLanguage;
	$.getJSON('/wtk/ajxUpdateLang.php?Lang=' + fncLanguage, function(data) {
        document.getElementById('selLangList').value = fncLanguage;
		$.each(data, function(key, value) {
			if (key in gloLangArray){
				for (let i=1; i <= gloLangArray[key]; i++){
					$('#lang'+key+i).html(value);
				}
			} else {
				$('#lang'+key).html(value);
			}
		});
	});
} // wtkLangUpdate
function wtkGoToURL(fncPage, fncId='', fncRNG='', fncTarget='') {
    // WTK Browse pages call this instead of ajaxGo when using MPA
    let fncGoToURL = fncPage;
    let fncParams = new FormData();
    if (!fncGoToURL.includes('.')) {
        fncGoToURL += '.php';
    }
    var fncForm = document.createElement('form');
    fncForm.setAttribute('method', 'post');
    fncForm.setAttribute('action', fncGoToURL);
    if (fncTarget == 'targetBlank') {
        fncForm.setAttribute('target', 'ViewFile');
    }
    if (fncId != '') {
        fncParams.append('id', fncId);
        let fncHiddenField = document.createElement('input');
        fncHiddenField.setAttribute('type', 'hidden');
        fncHiddenField.setAttribute('name', 'id');
        fncHiddenField.setAttribute('value', fncId);
        fncForm.appendChild(fncHiddenField);
    }
    if (fncRNG != '') {
        let fncHiddenField = document.createElement('input');
        fncHiddenField.setAttribute('type', 'hidden');
        fncHiddenField.setAttribute('name', 'rng');
        fncHiddenField.setAttribute('value', fncRNG);
        fncForm.appendChild(fncHiddenField);
    }
    if (pgApiKey != '') {
        let fncHiddenField = document.createElement('input');
        fncHiddenField.setAttribute('type', 'hidden');
        fncHiddenField.setAttribute('name', 'apiKey');
        fncHiddenField.setAttribute('value', pgApiKey);
        fncForm.appendChild(fncHiddenField);
    }
    document.body.appendChild(fncForm);

    if (fncTarget == 'targetBlank') {
        window.open('', 'ViewFile');
    } else {
    //  window.open('');
    //  window.location.href = fncGoToURL; // redirect
    }
    fncForm.submit();
}

function wtkOpenPage(fncPage, fncId, fncRng){
    // used for SPA pages to be able to open other SPA pages in a new tab
    let fncParams = 'apiKey=' + pgApiKey + '&p=ok&id=' + fncId + '&rng=' + fncRng;
    window.open(fncPage + '.php?' + fncParams );
}

function wtkSendEmail(fncModalId = '', fncURL = '/wtk/ajxSendEmail', fncFormName = 'emailForm', fncEmailBtn = 'emailBtn'){
    let fncEmail = $('#email').val();
    if (fncEmail == '') {
        wtkAlert('You must enter an email address.');
    } else {
        if (isValidEmail(fncEmail)) {
            let fncAjaxURL = fncURL + '.php';
            wtkDisableBtn(fncEmailBtn);
            let fncFormData = $('#' + fncFormName).serialize();
            fncFormData = fncFormData + '&formName=' + fncFormName ;
            $.ajax({
              type: "POST",
              url: fncAjaxURL,
              data: (fncFormData),
                success: function(data) {
					let fncJSON = $.parseJSON(data);
					if (fncJSON.result == 'OK'){
						M.toast({html: "Your message has been sent.", classes: "green rounded"});
                        if (fncModalId == '') {
                            $('#' + fncFormName).addClass('hide');
                        } else {
                            let fncId = document.getElementById(fncModalId);
    						let fncModal = M.Modal.getInstance(fncId);
    						fncModal.close();
                        }
					} else {
						M.toast({html: "Email failed to send", classes: "red rounded"});
					}
                }
            })
        }else{ // not valid email
            wtkAlert("Please enter a valid email address.");
        }
    } // email entered
} // wtkSendEmail

// WTK Validation Logic  -- BEGIN
function wtkValidate(fncCaller, fncDataType) {
    let fncNumValue;  // ABS 06/20/14
    let pgValueChanged = false;
    let res;
    if (fncCaller.type === "radio") {
        let fncParentName = fncCaller.name;
        if (document.forms.wtkForm[fncParentName] !== fncCaller.value ) {
            pgValueChanged = true;
        }
    }else{
        if (fncCaller.SavedValue != fncCaller.value) {
            pgValueChanged = true;
        }
		if (fncDataType == 'DATE'){
			if (pgVarMobile != 'N'){
	            pgValueChanged = true;
			}
		}
    }
    fncCaller.Valid = "true";
    let fncPointer;
    fncPointer = fncCaller;
    if (fncPointer.required == true && (!fncPointer.value || fncPointer.value == "")) {
        if (pgLanguage == 'esp') {
            wtkAlert(fncPointer.placeholder + ": necesario");
        }else{
            wtkAlert(fncPointer.placeholder + ": Required field");
        }
        fncCaller.Valid = "false";
    } else if (fncPointer.SavedValue != fncPointer.value) {
        switch(fncDataType) {
          case 'ZIPCODE':
                zVal = fncPointer.value + '';
                if (zVal == ''){
                    res = true;
                }else{
                    res = isValidZip(zVal);
                    if (res != -1 ) {
                        fncPointer.value = res;
                        res = true;
                    }else{
                        wtkAlert(fncPointer.placeholder + " needs to be a valid zipcode.");
                        fncCaller.Valid = "false";
                        res = false;
                      }
                }
                return res;
            case 'PHONE':
                pVal = fncPointer.value + '';
                if(pVal == ''){
                    res = true;
                }else{
                    res = isPhoneNum(pVal);
                    if (res != -1) {
                        fncPointer.value = res;
                        res = true;
                    }else{
                        wtkAlert(fncPointer.placeholder + " needs to be a valid phone number.");
                        fncCaller.Valid = "false";
                        res = false;
                    }
                }
                return res;
            case 'EMAIL':
                let elementName = fncCaller.name;
                if (isValidEmail(fncPointer.value)) {
                    fncCaller.Valid = "true";
                }else{
                    fncCaller.Valid = "false";
                    let fncLabel = fncPointer.placeholder;
                    if ((fncLabel === undefined) || (fncLabel == '')) {
                        fncLabel = 'Email';
                    }
                    if (pgLanguage == 'esp') {
                        wtkAlert("Por favor, introduce una dirección de correo electrónico válida.");
                    }else{
                        wtkAlert("Please enter a valid email address.");
                    }
                }
                return(0);
            case "STRING" : // check the Caps statement
            	if (fncPointer.Caps == "WORD") {
                    //let pattern = /(\w)(\w*)/;
                    let pattern = /([A-Za-z0-9_���������������������])([A-Za-z0-9_���������������������]*)/;
                    let a = fncPointer.value.split(/\s+/g);
                    for (i = 0 ; i < a.length ; i ++ ) {
                        let parts = a[i].match(pattern);
                        let firstLetter = parts[1].toUpperCase();
                        let restOfWord = parts[2].toLowerCase();
                        a[i] = firstLetter + restOfWord;
                    }
                    fncPointer.value = a.join(' ');
                }
                if (fncPointer.Caps == "ALL") {
                    let fncCaps = fncPointer.value;
                    fncPointer.value = fncCaps.toUpperCase();
                }
                return(0);
            case "NUMERIC" :    // test for numeric entry
// strip out commas then test for number; change all fncPointer.value below in this case to fncNumValue
				fncNumValue = fncPointer.value;
				fncNumValue = fncNumValue.split(',').join('');
				fncNumValue = fncNumValue.split('$').join(''); // ABS 11/28/14
                if (isNaN(fncNumValue)) {
					if (pgLanguage == 'esp') {
	                    wtkAlert(fncPointer.placeholder + ": Numerico");
					}else{
	                    wtkAlert(fncPointer.placeholder + ": Numeric field");
					}
                    fncCaller.Valid = "false";
                    // set to minimum if required
                    if (fncPointer.Minimum) {
                        fncPointer.value = fncPointer.Minimum;
                    } else { // otherwise zero/zed
		              	if (fncPointer.SavedValue) {
                          fncPointer.value = fncPointer.SavedValue;
                    	} else {
                          fncPointer.value = 0;
                      	}
                    }
//                    fncPointer.select();
                    fncPointer.focus();  // abs 03/04/13
                }else{
                    fncPointer.value = fncNumValue;  // ABS 10/09/16
                }
                // minimum value
                if (fncPointer.Minimum && fncNumValue < fncPointer.Minimum) {
					if (pgLanguage == 'esp') {
	                    wtkAlert("El valor minimo " + fncPointer.placeholder + ": " + fncPointer.Minimum);
					}else{
    	                wtkAlert("Minimum value " + fncPointer.placeholder + ": " + fncPointer.Minimum);
					}
                    fncCaller.Valid = "false";
                    fncPointer.value = fncPointer.Minimum + "";
                    fncPointer.select();
                }
                // maximum value
                if (fncPointer.Maximum && fncNumValue > fncPointer.Maximum) {
					if (pgLanguage == 'esp') {
	                    wtkAlert("El valor maximo " + fncPointer.placeholder + ": " + fncPointer.Maximum);
					}else{
    	                wtkAlert("Maximum value " + fncPointer.placeholder + ": " + fncPointer.Maximum);
					}
                    fncPointer.value = fncPointer.Maximum + "";
                    fncPointer.select();
                }
                // set precision to decimal places
                if (fncPointer.Places) {
                    let i;
                    let val;
                    val = fncNumValue + '';
                    let decPos = val.indexOf('.');
                    if (decPos == -1) {
                        val += '.';
                        for (i=0; i < fncPointer.Places; i++) {
                            val += '0';
                        }
                    } else {
                        let actualDec = (val.length - 1) - decPos;
                        let diff = fncPointer.Places - actualDec;
                        if (diff > 0) {
                            for (i=0; i < diff; i++) {
                                val += '0';
                            }
                        }
                        if (diff < 0) {
                            val = val.substr(0,(decPos + fncPointer.Places + 1));
                        }
                    }
                  fncPointer.value = val;
                }
                return(0);
            case "DATE" :
                if (pgVarMobile == 'N'){ // change from != Y to == N
                    let dVal;
                    let iD,iM,iY;
                    dVal = fncPointer.value + '';
          // 06/25/07 make so blanked date does not return invalid message if not required
			        if (dVal== ''){
			            res = true;
			        }else{
			            res = isDate(fncPointer, dVal);
			        }
                    if (res==false){
                       fncCaller.Valid = "false";
                    }
				} else {
					res = true;
	        	}
				return res;
            case "TIME" :
              	if(fncPointer.value) {
	                let d = new Date("07/07/1962 "+fncPointer.value);
	                 //let t = Date.parse(fncPointer.value);
	                if(isNaN(d)) {
	                    wtkAlert(fncPointer.placeholder + ": Invalid time");
	                    fncCaller.Valid = "false";
	                   	fncPointer.select();
	                    return false;
	                }
            	}
                return true;
            case "CURRENCY" :
                let curval;
                let val;
                val = fncPointer.value + '';
                curval=val;
                // test for numeric entry
                if (val.length==0) {
                    wtkAlert(fncPointer.placeholder + ": CURRENCY field");
                 	fncCaller.Valid = "false";
                   // set to minimum if required
                    if (fncPointer.Minimum) {
                        fncPointer.value = "$"+fncPointer.Minimum ;
                    }else{  // otherwise zero/zed
                        fncPointer.value = "$"+ 0;
                    }
                    fncPointer.select();
                    return(0);
                }
                let i;
                let decPos = val.indexOf('$');
                if (decPos == 0) {
                    val = val.substr(1,(val.length-2));
                    curval= val;
                }

              	val = curval + '';
               	while(true) {
                	decPos = val.indexOf(',');
                  	if (decPos == -1){
                   		break;
					}else{
                        val = val.substr(0,decPos)+val.substr(decPos+1,val.length-decPos-3);
                        curval= val;
                	}
              	}
                let ival=0;
                ival=curval;
                  // test for numeric entry
                if (isNaN(ival)) {
                    wtkAlert(fncPointer.placeholder + ": Mast be CURRENCY($###,###.##)");
						fncCaller.Valid = "false";
                   // set to minimum if required
                    if (fncPointer.Minimum) {
                        fncPointer.value = "$"+fncPointer.Minimum;
                    }else{ // otherwise zero/zed
                        fncPointer.value = "$"+ 0;
                    }
                    fncPointer.select();
                    return(0);
                }
                // minimum value
                if (fncPointer.Minimum && ival < fncPointer.Minimum) {
                    wtkAlert("Minimum value " + fncPointer.placeholder + ": " + fncPointer.Minimum);
						fncCaller.Valid = "false";
                   	fncPointer.value = "$"+fncPointer.Minimum ;
                    fncPointer.select();
                }
                // maximum value
                if (fncPointer.Maximum && ival > fncPointer.Maximum) {
                    wtkAlert("Maximum value " + fncPointer.placeholder + ": " + fncPointer.Maximum);
                    fncPointer.value = "$"+fncPointer.Maximum ;
                    fncPointer.select();
                }
                // set precision to decimal places
                if (fncPointer.Places) {
                    decPos = curval.indexOf('.');
                    if (decPos == -1) {
                        curval += '.';
                        for (i=0; i < fncPointer.Places; i++) {
                            curval += '0';
                        }
                    }else{
                        let actualDec = (curval.length - 1) - decPos;
                        let diff = fncPointer.Places - actualDec;
                        if (diff > 0) {
                            for (i=0; i < diff; i++) {
                                curval += '0';
                            }
                        }
                        if (diff < 0) {
                            curval = curval.substr(0,(decPos + fncPointer.Places + 1));
                        }
                    }
                    fncPointer.value = "$"+curval;
                }
                return(0);
        } // switch(fncDataType)
    } // value changed
} // wtkValidate

function reValidateForm() {
    for (let ii=0; ii<document.forms.wtkForm.elements.length; ii++){
        if(document.forms.wtkForm.elements[ii].Valid == "false" || document.forms.wtkForm.elements[ii].Value == ""){  //If the field is left blank or incorrect input
            wtkAlert("The following field was either left blank and is required or does not have a valid value! \n" + document.forms.wtkForm.elements[ii].placeholder);
            document.forms.wtkForm.elements[ii].focus();
            break;
            return;
        }else{
            document.forms.wtkForm.elements[ii].Valid = true;
        }
    }
    document.forms.wtkForm.submit();
}
//  Beginning of Date Validation Functions  --------------------------------------------------------------------------------------------------
/**
 * DHTML date validation script. Courtesy of SmartWebby.com (http://www.smartwebby.com/dhtml/)
 */

function isInteger(s){
    for (let i = 0; i < s.length; i++){
        // Check that current character is number.
        let c = s.charAt(i);
        if (((c < "0") || (c > "9"))) return false;
    }
    // All characters are numbers.
    return true;
}

function stripCharsInBag(s, bag){
    let returnString = "";
    // Search through string's characters one by one.
    // If character is not in bag, append to returnString.
    for (let i = 0; i < s.length; i++){
        let c = s.charAt(i);
        if (bag.indexOf(c) == -1) returnString += c;
    }
    return returnString;
}

function daysInFebruary (year){
  // February has 29 days in any year evenly divisible by four,
    // EXCEPT for centurial years which are not also divisible by 400.
    return (((year % 4 == 0) && ( (!(year % 100 == 0)) || (year % 400 == 0))) ? 29 : 28 );
}
function daysArray(n) {
  for (let i = 1; i <= n; i++) {
      this[i] = 31
      if (i==4 || i==6 || i==9 || i==11) {this[i] = 30}
      if (i==2) {this[i] = 29}
  }
  return this
}

function isDate(pointer, dtStr){
    // Declaring valid date character, minimum year and maximum year
    let minYear=1900;
    let maxYear=2100;
    let pgVarDateDelimiter = '/';
    let daysInMonth = daysArray(12)
    let pos1=dtStr.indexOf(pgVarDateDelimiter)
    let pos2=dtStr.indexOf(pgVarDateDelimiter,pos1+1)
    let strMonth=dtStr.substring(0,pos1)
    let strDay=dtStr.substring(pos1+1,pos2)
    let strYear=dtStr.substring(pos2+1)
    strYr=strYear
    if (strDay.charAt(0)=="0" && strDay.length>1) strDay=strDay.substring(1)
    if (strMonth.charAt(0)=="0" && strMonth.length>1) strMonth=strMonth.substring(1)
    for (let i = 1; i <= 3; i++) {
        if (strYr.charAt(0)=="0" && strYr.length>1) strYr=strYr.substring(1)
    }
    month=parseInt(strMonth)
    day=parseInt(strDay)
    year=parseInt(strYr)
    if (pos1==-1 || pos2==-1){
        wtkAlert(pointer.placeholder + ": Invalid date.  The date format should be : mm/dd/yyyy");
        return false;
    }
    if (strMonth.length<1 || month<1 || month>12){
        wtkAlert(pointer.placeholder + ": Invalid date.  Please enter a valid month");
        return false;
    }
    if (strDay.length<1 || day<1 || day>31 || (month==2 && day>daysInFebruary(year)) || day > daysInMonth[month]){
        wtkAlert(pointer.placeholder + ": Invalid date.  Please enter a valid day");
        return false;
    }
    if (strYear.length == 4 ) {
        if (year==0 || year<minYear || year>maxYear){
            wtkAlert(pointer.placeholder + ": Invalid date.  Please enter a valid 4 digit year between "+minYear+" and "+maxYear);
            return false;
        }
    } else {
        if (strYear.length == 2 ) {
            // do nothing while testing
            // wtkAlert(pointer.placeholder + ": Two-Digit Year, but that's Ok")
            return true;
        } else {
            wtkAlert(pointer.placeholder + ": Invalid date.  Please enter a valid 4 digit year between "+minYear+" and "+maxYear);
            return false;
        }
    }
/*
  if (strYear.length != 4 || year==0 || year<minYear || year>maxYear){
    wtkAlert(pointer.placeholder + ": Invalid date.  Please enter a valid 4 digit year between "+minYear+" and "+maxYear)
    return false
  }
*/
    if (dtStr.indexOf(pgVarDateDelimiter,pos2+1)!=-1 || isInteger(stripCharsInBag(dtStr, pgVarDateDelimiter))==false){
        wtkAlert(pointer.placeholder + ": Invalid date.  Please enter a valid date");
        return false;
    }
    return true
} // isDate

function wtkFormatDate(fncDate){
	var fncDay = fncDate.getDate();
	var fncMonth = fncDate.getMonth() + 1;
	var fncYear = fncDate.getFullYear();
	if (fncDay < 10) {
		fncDay = '0' + fncDay;
	}
	if (fncMonth < 10) {
		fncMonth = '0' + fncMonth;
	}
	let fncResult = fncYear + '-' + fncMonth + '-' + fncDay;
	return fncResult;
}

function isValidZip(fncZip){
  let str = fncZip.split(' ').join('');
  str = str.split('-').join('');
  let regexObj = /^([A-Z,a-z,0-9]{5})?$/;
  let fncResult = regexObj.test(str);
  if (fncResult ==false){
	  regexObj = /^([A-Z,a-z,0-9]{6})?$/;
	  fncResult = regexObj.test(str);
      if(fncResult ==false){
      	regexObj = /^([A-Z,a-z,0-9]{9})?$/;
      	fncResult = regexObj.test(str);
        if (fncResult){
            fncResult = str.substring(0, 5) + "-" + str.substring(5, str.length);
        } else {
            fncResult = -1;
        }
      } else {
     	fncResult = str.substring(0, 3) + " " + str.substring(3, str.length);
      }
   } else {
      fncResult = str ;
   }
   return fncResult;
} // isValidZip

function isPhoneNum(fncPhone){
    let str = fncPhone.split('-').join(' ');
	let fncCount = str.length;
    let fncResult = -1;
    str = str.split('(').join('');
    if(str.length != fncCount && (fncCount - str.length)%2 == 0){
		return -1;
    }
    fncCount = str.length;
    str = str.split(')').join('');
    if (str.length != fncCount && (fncCount - str.length)%2 == 0){
		return -1;
    }
    str = str.split(' ').join('').trim();
    if (str.length != 10 || !isInteger(str) ){
		return -1;
	}

    let temp = str.substring(0,3) + " " +  str.substring(3,6)  + " " +  str.substring(6,10)  ;
    let regexObj = /^\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$/;
    let res = regexObj.test(temp);
    if (res) {
		fncResult = temp.replace(regexObj, "($1) $2-$3");
    }else{ // Invalid phone number
		fncResult = -1;
    }
	return fncResult;
 }// end isPhoneNum

//  End of Date Validation Functions  -----------------------------------------------------------------------------------------------------------
function isValidEmail(fncEmail) {
    let fncEmailReg = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,10})?$/;
    if (!fncEmailReg.test( fncEmail ) ) {
        return false;
    } else {
        return true;
    }
}

function isNumber(n, fncBlankOK) {
// strip out $ and commas then verify is number and return
// fixed number with 2 decimal places. If .00 then strip that out before returning.
   wtkDebugLog('isNumber top: n = ' + n);
   let fncStr = n.toString();
   fncStr = fncStr.replace('$','');
   fncStr = fncStr.replace(',','');
   wtkDebugLog('isNumber top: fncStr = ' + fncStr);
   let fncResult = false;
   if ((fncBlankOK == 'Y') && (fncStr == '')) {
       fncResult = true;
   } else {
       fncResult = !isNaN(parseFloat(fncStr)) && !isNaN(fncStr - 0);
       if (fncResult == false) {
           wtkAlert('Value entered needs to be a number like 9, 14, 27.');
           wtkDebugLog('FALSE isNumber: n = ' + n + '; fncNum = ' + fncStr + '; fncBlankOK = ' + fncBlankOK);
       } else {
           let fncNum = roundToPrecision(fncStr);
           let fncStr2 = fncNum.toString();
           fncResult = fncStr2.replace(/\.00$/,'');
           wtkDebugLog('TRUE isNumber: n = ' + n + '; fncNum = ' + fncStr + '; fncBlankOK = ' + fncBlankOK);
       }
   } // not blank
   return fncResult;
} // isNumber
// WTK Validation Logic  -- END

function formatBytes(bytes, decimals = 2) {
    if (bytes === 0) return '0 Bytes';

    const k = 1024;
    const dm = decimals < 0 ? 0 : decimals;
    const sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];

    let i = Math.floor(Math.log(bytes) / Math.log(k));

    return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
}

function formatBytesMinimized(a,b=2){if(0===a)return"0 Bytes";const c=0>b?0:b,d=Math.floor(Math.log(a)/Math.log(1024));return parseFloat((a/Math.pow(1024,d)).toFixed(c))+" "+["Bytes","KB","MB","GB","TB","PB","EB","ZB","YB"][d]}

function elementExist(fncElemId) {
    // test to see if HTML object like hidden field exists
    let fncElement = document.getElementById(fncElemId);
    if (typeof(fncElement) != 'undefined' && fncElement != null){
//  if (document.getElementById(fncElemId).length > 0) {
        wtkDebugLog('elementExist true for ' + fncElemId);
        return true;
    } else {
        wtkDebugLog('elementExist false for ' + fncElemId);
        return false;
    }
}
function getCookie(cname) {
  let name = cname + '=';
  let decodedCookie = decodeURIComponent(document.cookie);
  let ca = decodedCookie.split(';');
  for (let i = 0; i < ca.length; i++) {
      let c = ca[i];
      while (c.charAt(0) == ' ') {
          c = c.substring(1);
      }
      if (c.indexOf(name) == 0) {
          return c.substring(name.length, c.length);
      }
  }
  return '';
}

function roundToPrecision(inputNum){
    let fncBigNum = (inputNum * 100).toFixed(2); //.toFixed(2) required to prevent .499999997 math failures
    let fncRounded = Math.round(fncBigNum);
    let fncResult = (fncRounded / 100);
    return(fncResult);  // ABS 07/30/12
}
function nl2br(str, is_xhtml) {
	let breakTag = (is_xhtml || typeof is_xhtml === 'undefined') ? '<br />' : '<br>';
    return (str + '').replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1'+ breakTag +'$2');
}

function waitLoad(fncMode) {
    if (fncMode == 'on') {
        $('#fullPage').addClass('shade-background');
        $('#loaderDiv1').removeClass('hide');
        $('#loaderDiv1').removeClass('active');
        $('#loaderDiv2').addClass('active');
        let fncDiv = document.getElementById('loaderDiv1');
        fncDiv.style.removeProperty('display');
    } else {
        $('#loaderDiv2').removeClass('active');
        $('#loaderDiv1').addClass('hide');
        $('#fullPage').removeClass('shade-background');
    }
} // waitLoad

function scorePassword(fncPass) {
    let fncScore = 0;
    if (!fncPass){
        return fncScore;
    } else {
        // award every unique letter until 5 repetitions
        let letters = new Object();
        for (let i=0; i<fncPass.length; i++) {
            letters[fncPass[i]] = (letters[fncPass[i]] || 0) + 1;
            fncScore += 5.0 / letters[fncPass[i]];
        }

        // bonus points for mixing it up
        let variations = {
            digits: /\d/.test(fncPass),
            lower: /[a-z]/.test(fncPass),
            upper: /[A-Z]/.test(fncPass),
            nonWords: /\W/.test(fncPass),
        }

        let variationCount = 0;
        for (let check in variations) {
            variationCount += (variations[check] == true) ? 1 : 0;
        }
        fncScore += (variationCount - 1) * 10;
        return parseInt(fncScore);
    }
} // scorePassword

function checkPassStrength(fncPass) {
    let fncResult = 'too weak';
    let fncScore = scorePassword(fncPass);
    if (fncScore > 80) {
        M.toast({html: 'Password is strong', classes: 'rounded green'});
    } else if (fncScore > 60) {
        M.toast({html: 'Password is good', classes: 'rounded green accent-3 black-text'});
    } else if (fncScore > 30) {
        M.toast({html: 'Password is weak - use numbers and both UPPER and lower case letters', classes: 'rounded orange'});
    } else {
        M.toast({html: 'Password is too weak - use numbers and both UPPER and lower case letters', classes: 'rounded red'});
    }
    return fncScore;
} // checkPassStrength

// BEGIN Drag and Drop functionality
// used by /admin/widgetMgr.php and possibly other files for UI method of changing Priorities within data
var pgFromDragId = 0;
var pgFromDragPos = 0;

function wtkDragStart(fncId,fncPos) {
    pgFromDragId = fncId;
    pgFromDragPos = fncPos;
    console.log('wtkDragStart called: pgFromDragId = ' + pgFromDragId );
}
function wtkDragOver(ev) {
    ev.preventDefault(); // necessary
}
function wtkDropId(fncToId, fncToPos) {
    console.log('wtkDropId called: FromId = ' + pgFromDragId + '; ToId = ' + fncToId);
    let fncTable = $('#wtkDragTable').val();
    let fncColumn = $('#wtkDragColumn').val();
    let fncFilter = $('#wtkDragFilter').val();
    $.ajax({
        type: 'POST',
        url:  '/wtk/ajxPriorityAdj.php',
        data: { apiKey: pgApiKey, tbl: fncTable, col: fncColumn, filter: fncFilter,
            fromId: pgFromDragId, toId: fncToId, fromPos: pgFromDragPos, toPos: fncToPos},
            success: function(data) {
                let fncURL = $('#wtkDragRefresh').val();
                if ($('#wtkDragLocation').val() == 'table') {
                    wtkBrowseReset(fncURL, fncTable, fncFilter);
                } else {
                    wtkModalUpdate(fncURL, 0, fncFilter);
                }
            }
    })
}
//  END  Drag and Drop functionality
// -->
